%define         use_systemd   1
%define orprefix            %{_usr}/local/%{name}
%define zlib_prefix         %{orprefix}/zlib
%define pcre_prefix         %{orprefix}/pcre
%define openssl_prefix      %{orprefix}/openssl111

%define orprefix_asan            %{_usr}/local/%{name}-asan
%define openssl_prefix_asan      %{_usr}/local/%{name}-asan/openssl111
%define zlib_prefix_asan         %{_usr}/local/%{name}-asan/zlib
%define pcre_prefix_asan         %{_usr}/local/%{name}-asan/pcre

%define orprefix_debug    	    %{_usr}/local/%{name}-debug
%define openssl_prefix_debug  	%{_usr}/local/%{name}-debug/openssl111
%define zlib_prefix_debug       %{_usr}/local/%{name}/zlib
%define pcre_prefix_debug       %{_usr}/local/%{name}/pcre

%global debug_package %{nil}

Summary:        OpenResty, scalable web platform by extending NGINX with Lua
Name:           openresty
Version:        1.21.4.4
Release:        2%{?dist}
License:        BSD
URL:            https://openresty.org/

Source0:        https://openresty.org/download/openresty-%{version}.tar.gz
Source1:        openresty.service
Source2:        openresty.init

Patch3000:      add-option-out-dir-on-configure.patch
Patch3001:      add-loongarch-support.patch

BuildRequires:  perl-File-Temp
BuildRequires:  ccache, gcc, make, perl, systemtap-sdt-devel, valgrind-devel
BuildRequires:  openresty-zlib-devel >= 1.2.12-1
BuildRequires:  openresty-openssl111-devel >= 1.1.1w-1
BuildRequires:  openresty-pcre-devel >= 8.45-1
Requires:       openresty-zlib >= 1.2.12-1
Requires:       openresty-openssl111 >= 1.1.1w-1
Requires:       openresty-pcre >= 8.45-1
ExcludeArch:    loongarch64

%if 0%{?use_systemd}

BuildRequires:  systemd
Requires:       systemd

%endif


%description
This package contains the core server for OpenResty. Built for production
uses.

OpenResty is a full-fledged web platform by integrating the standard Nginx
core, LuaJIT, many carefully written Lua libraries, lots of high quality
3rd-party Nginx modules, and most of their external dependencies. It is
designed to help developers easily build scalable web applications, web
services, and dynamic web gateways.

By taking advantage of various well-designed Nginx modules (most of which
are developed by the OpenResty team themselves), OpenResty effectively
turns the nginx server into a powerful web app server, in which the web
developers can use the Lua programming language to script various existing
nginx C modules and Lua modules and construct extremely high-performance
web applications that are capable to handle 10K ~ 1000K+ connections in
a single box.

%package debug
Summary:        The debug version of OpenResty

BuildRequires:  openresty-zlib-devel >= 1.2.12-1
BuildRequires:  openresty-openssl111-debug-devel >= 1.1.1w-1
BuildRequires:  openresty-pcre-devel >= 8.45-1
Requires:       openresty-zlib >= 1.2.12-1
Requires:       openresty-openssl111-debug >= 1.1.1w-1
Requires:       openresty-pcre >= 8.45-1

%description debug
This package contains the debug version of the core server for OpenResty.
Built for development purposes only.

DO NOT USE THIS PACKAGE IN PRODUCTION!

OpenResty is a full-fledged web platform by integrating the standard Nginx
core, LuaJIT, many carefully written Lua libraries, lots of high quality
3rd-party Nginx modules, and most of their external dependencies. It is
designed to help developers easily build scalable web applications, web
services, and dynamic web gateways.

By taking advantage of various well-designed Nginx modules (most of which
are developed by the OpenResty team themselves), OpenResty effectively
turns the nginx server into a powerful web app server, in which the web
developers can use the Lua programming language to script various existing
nginx C modules and Lua modules and construct extremely high-performance
web applications that are capable to handle 10K ~ 1000K+ connections in
a single box.

%package asan
Summary:        The AddressSanitizer (ASAN) version of OpenResty
BuildRequires:  openresty-zlib-asan-devel >= 1.2.12-1
BuildRequires:  openresty-openssl111-asan-devel >= 1.1.1w-1
BuildRequires:  openresty-pcre-asan-devel >= 8.45-1

Requires:       openresty-zlib-asan >= 1.2.12-1
Requires:       openresty-openssl111-asan >= 1.1.1w-1
Requires:       openresty-pcre-asan >= 8.45-1

%description asan
This package contains a gcc AddressSanitizer version of the core server
for OpenResty with
gcc's AddressSanitizer built in. Built for development purposes only.

DO NOT USE THIS PACKAGE IN PRODUCTION!

OpenResty is a full-fledged web platform by integrating the standard Nginx
core, LuaJIT, many carefully written Lua libraries, lots of high quality
3rd-party Nginx modules, and most of their external dependencies. It is
designed to help developers easily build scalable web applications, web
services, and dynamic web gateways.

By taking advantage of various well-designed Nginx modules (most of which
are developed by the OpenResty team themselves), OpenResty effectively
turns the nginx server into a powerful web app server, in which the web
developers can use the Lua programming language to script various existing
nginx C modules and Lua modules and construct extremely high-performance
web applications that are capable to handle 10K ~ 1000K+ connections in
a single box.

%package resty

Summary:        OpenResty command-line utility, resty
Requires:       perl, openresty >= %{version}-%{release}
Requires:       perl(File::Spec), perl(FindBin), perl(List::Util), perl(Getopt::Long), perl(File::Temp), perl(POSIX), perl(Time::HiRes)
BuildArch:      noarch


%description resty
This package contains the "resty" command-line utility for OpenResty, which
runs OpenResty Lua scripts on the terminal using a headless NGINX behind the
scene.

OpenResty is a full-fledged web platform by integrating the standard Nginx
core, LuaJIT, many carefully written Lua libraries, lots of high quality
3rd-party Nginx modules, and most of their external dependencies. It is
designed to help developers easily build scalable web applications, web
services, and dynamic web gateways.


%package doc

Summary:        OpenResty documentation tool, restydoc
Requires:       perl, perl(Getopt::Std), perl(File::Spec), perl(FindBin), perl(Cwd), perl(File::Temp), perl(Pod::Man), perl(Pod::Text)
Requires:       groff-base

Provides:       restydoc, restydoc-index, md2pod.pl
BuildArch:      noarch



%description doc
This package contains the official OpenResty documentation index and
the "restydoc" command-line utility for viewing it.

OpenResty is a full-fledged web platform by integrating the standard Nginx
core, LuaJIT, many carefully written Lua libraries, lots of high quality
3rd-party Nginx modules, and most of their external dependencies. It is
designed to help developers easily build scalable web applications, web
services, and dynamic web gateways.


%package opm

Summary:        OpenResty Package Manager
Requires:       perl, openresty >= %{version}-%{release}, perl(Digest::MD5)
Requires:       openresty-doc >= %{version}-%{release}, openresty-resty >= %{version}-%{release}
Requires:       curl, tar, gzip
Requires:       perl(Encode), perl(FindBin), perl(File::Find), perl(File::Path), perl(File::Spec), perl(Cwd), perl(Digest::MD5), perl(File::Copy), perl(File::Temp), perl(Getopt::Long)

BuildArch:      noarch


%description opm
This package provides the client side tool, opm, for OpenResty Pakcage Manager (OPM).


%prep
%setup -n "openresty-%{version}"
%patch3000 -p1
%ifarch loongarch64
%patch3001 -p1
%endif

%build
./configure \
    --out-dir='build' \
    --prefix="%{orprefix}" \
    --with-cc='ccache gcc -fdiagnostics-color=always' \
    --with-cc-opt="-DNGX_LUA_ABORT_AT_PANIC -I%{zlib_prefix}/include -I%{pcre_prefix}/include -I%{openssl_prefix}/include" \
    --with-ld-opt="-L%{zlib_prefix}/lib -L%{pcre_prefix}/lib -L%{openssl_prefix}/lib -Wl,-rpath,%{zlib_prefix}/lib:%{pcre_prefix}/lib:%{openssl_prefix}/lib" \
    --with-pcre-jit \
    --without-http_rds_json_module \
    --without-http_rds_csv_module \
    --without-lua_rds_parser \
    --with-stream \
    --with-stream_ssl_module \
    --with-stream_ssl_preread_module \
    --with-http_v2_module \
    --without-mail_pop3_module \
    --without-mail_imap_module \
    --without-mail_smtp_module \
    --with-http_stub_status_module \
    --with-http_realip_module \
    --with-http_addition_module \
    --with-http_auth_request_module \
    --with-http_secure_link_module \
    --with-http_random_index_module \
    --with-http_gzip_static_module \
    --with-http_sub_module \
    --with-http_dav_module \
    --with-http_flv_module \
    --with-http_mp4_module \
    --with-http_gunzip_module \
    --with-threads \
    --with-compat \
    --with-luajit-xcflags='-DLUAJIT_NUMMODE=2 -DLUAJIT_ENABLE_LUA52COMPAT' \
    -j`nproc`

make -f 'Makefile-build' -j`nproc`


./configure \
    --out-dir='build-debug' \
    --prefix="%{orprefix_debug}" \
    --with-cc='ccache gcc -fdiagnostics-color=always' \
    --with-debug \
    --with-cc-opt="-I%{zlib_prefix_debug}/include -I%{pcre_prefix_debug}/include -I%{openssl_prefix_debug}/include -O0" \
    --with-ld-opt="-L%{zlib_prefix_debug}/lib -L%{pcre_prefix_debug}/lib -L%{openssl_prefix_debug}/lib -Wl,-rpath,%{zlib_prefix_debug}/lib:%{pcre_prefix_debug}/lib:%{openssl_prefix_debug}/lib" \
    --with-pcre-jit \
    --without-http_rds_json_module \
    --without-http_rds_csv_module \
    --without-lua_rds_parser \
    --with-stream \
    --with-stream_ssl_module \
    --with-stream_ssl_preread_module \
    --with-http_v2_module \
    --without-mail_pop3_module \
    --without-mail_imap_module \
    --without-mail_smtp_module \
    --with-http_stub_status_module \
    --with-http_realip_module \
    --with-http_addition_module \
    --with-http_auth_request_module \
    --with-http_secure_link_module \
    --with-http_random_index_module \
    --with-http_gzip_static_module \
    --with-http_sub_module \
    --with-http_dav_module \
    --with-http_flv_module \
    --with-http_mp4_module \
    --with-http_gunzip_module \
    --with-threads \
    --with-poll_module \
    --with-compat \
    --with-luajit-xcflags='-DLUAJIT_NUMMODE=2 -DLUAJIT_ENABLE_LUA52COMPAT -O0' \
    -j`nproc`

make -f 'Makefile-build-debug' -j`nproc`

export ASAN_OPTIONS=detect_leaks=0

./configure \
    --out-dir='build-asan' \
    --prefix="%{orprefix_asan}" \
    --with-debug \
    --with-cc="ccache gcc -fsanitize=address" \
    --with-cc-opt="-I%{zlib_prefix_asan}/include -I%{pcre_prefix_asan}/include -I%{openssl_prefix_asan}/include -O1" \
    --with-ld-opt="-L%{zlib_prefix_asan}/lib -L%{pcre_prefix_asan}/lib -L%{openssl_prefix_asan}/lib -Wl,-rpath,%{zlib_prefix_asan}/lib:%{pcre_prefix_asan}/lib:%{openssl_prefix_asan}/lib" \
    --with-pcre-jit \
    --without-http_rds_json_module \
    --without-http_rds_csv_module \
    --without-lua_rds_parser \
    --with-stream \
    --with-stream_ssl_module \
    --with-stream_ssl_preread_module \
    --with-http_v2_module \
    --without-mail_pop3_module \
    --without-mail_imap_module \
    --without-mail_smtp_module \
    --with-http_stub_status_module \
    --with-http_realip_module \
    --with-http_addition_module \
    --with-http_auth_request_module \
    --with-http_secure_link_module \
    --with-http_random_index_module \
    --with-http_gzip_static_module \
    --with-http_sub_module \
    --with-http_dav_module \
    --with-http_flv_module \
    --with-http_mp4_module \
    --with-http_gunzip_module \
    --with-threads \
    --with-poll_module \
    --with-compat \
    --with-luajit-xcflags='-DLUAJIT_NUMMODE=2 -DLUAJIT_ENABLE_LUA52COMPAT -DLUAJIT_USE_VALGRIND -O1 -fno-omit-frame-pointer' \
    --with-no-pool-patch \
    -j`nproc`

make -f 'Makefile-build-asan' -j`nproc`



%install
make install -f 'Makefile-build' DESTDIR=%{buildroot}

rm -rf %{buildroot}%{orprefix}/luajit/share/man
rm -rf %{buildroot}%{orprefix}/luajit/lib/libluajit-5.1.a

mkdir -p %{buildroot}/usr/bin
ln -sf %{orprefix}/bin/resty %{buildroot}/usr/bin/
ln -sf %{orprefix}/bin/restydoc %{buildroot}/usr/bin/
ln -sf %{orprefix}/bin/opm %{buildroot}/usr/bin/
ln -sf %{orprefix}/nginx/sbin/nginx %{buildroot}/usr/bin/%{name}

%if 0%{?use_systemd}
mkdir -p %{buildroot}%{_unitdir}
%{__install} -p -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}/
%else
mkdir -p %{buildroot}/etc/init.d
%{__install} -p -m 0755 %{SOURCE2} %{buildroot}/etc/init.d/%{name}
%endif

make install -f 'Makefile-build-debug' DESTDIR=%{buildroot}

rm -rf %{buildroot}%{orprefix_debug}/luajit/share/man
rm -rf %{buildroot}%{orprefix_debug}/luajit/lib/libluajit-5.1.a
rm -rf %{buildroot}%{orprefix_debug}/bin/resty
rm -rf %{buildroot}%{orprefix_debug}/bin/restydoc
rm -rf %{buildroot}%{orprefix_debug}/bin/restydoc-index
rm -rf %{buildroot}%{orprefix_debug}/bin/md2pod.pl
rm -rf %{buildroot}%{orprefix_debug}/bin/nginx-xml2pod
rm -rf %{buildroot}%{orprefix_debug}/bin/opm
rm -rf %{buildroot}%{orprefix_debug}/pod/*
rm -rf %{buildroot}%{orprefix_debug}/resty.index

mkdir -p %{buildroot}/usr/bin
ln -sf %{orprefix_debug}/nginx/sbin/nginx %{buildroot}/usr/bin/%{name}-debug

make install -f 'Makefile-build-asan' DESTDIR=%{buildroot}

rm -rf %{buildroot}%{orprefix_asan}/luajit/share/man
rm -rf %{buildroot}%{orprefix_asan}/luajit/lib/libluajit-5.1.a
rm -rf %{buildroot}%{orprefix_asan}/bin/resty
rm -rf %{buildroot}%{orprefix_asan}/bin/restydoc
rm -rf %{buildroot}%{orprefix_asan}/bin/restydoc-index
rm -rf %{buildroot}%{orprefix_asan}/bin/md2pod.pl
rm -rf %{buildroot}%{orprefix_asan}/bin/opm
rm -rf %{buildroot}%{orprefix_asan}/bin/nginx-xml2pod
rm -rf %{buildroot}%{orprefix_asan}/pod/*
rm -rf %{buildroot}%{orprefix_asan}/resty.index

ln -sf %{orprefix_asan}/nginx/sbin/nginx %{buildroot}/usr/bin/%{name}-asan


# to silence the check-rpath error
export QA_RPATHS=$[ 0x0002 ]


%post

%if 0%{?use_systemd}
%systemd_post openresty.service
%else
/sbin/chkconfig --add %{name}
%endif


%preun
%if 0%{?use_systemd}
%systemd_preun openresty.service
%else
if [ $1 = 0 ]; then
    /sbin/service %{name} stop >/dev/null 2>&1
    /sbin/chkconfig --del %{name}
fi
%endif


%if 0%{?use_systemd}
%postun
%systemd_postun_with_restart openresty.service
%endif


%files
%defattr(-,root,root,-)

%dir %{orprefix}
%dir %{orprefix}/bin
%dir %{orprefix}/luajit
%dir %{orprefix}/lualib
%dir %{orprefix}/nginx
%dir %{orprefix}/nginx/html
%dir %{orprefix}/nginx/logs
%dir %{orprefix}/nginx/sbin
%if 0%{?use_systemd}
%{_unitdir}/%{name}.service
%else
/etc/init.d/%{name}
%endif
/usr/bin/%{name}
%{orprefix}/bin/openresty
%{orprefix}/site/lualib/
%{orprefix}/luajit/*
%{orprefix}/lualib/*
%{orprefix}/nginx/html/*
%{orprefix}/nginx/logs/
%{orprefix}/nginx/sbin/*
%config(noreplace) %{orprefix}/nginx/conf/*
%{orprefix}/COPYRIGHT

%files debug
%defattr(-,root,root,-)

/usr/bin/%{name}-debug
%{orprefix_debug}/bin/openresty
%{orprefix_debug}/site/lualib/
%{orprefix_debug}/luajit/*
%{orprefix_debug}/lualib/*
%{orprefix_debug}/nginx/html/*
%{orprefix_debug}/nginx/logs/
%{orprefix_debug}/nginx/sbin/*
%config(noreplace) %{orprefix_debug}/nginx/conf/*
%{orprefix_debug}/COPYRIGHT

%files asan
%defattr(-,root,root,-)

/usr/bin/%{name}-asan
%{orprefix_asan}/bin/openresty
%{orprefix_asan}/site/lualib/
%{orprefix_asan}/luajit/*
%{orprefix_asan}/lualib/*
%{orprefix_asan}/nginx/html/*
%{orprefix_asan}/nginx/logs/
%{orprefix_asan}/nginx/sbin/*
%config(noreplace) %{orprefix_asan}/nginx/conf/*
%{orprefix_asan}//COPYRIGHT


%files resty
%dir %{orprefix}/bin
%defattr(-,root,root,-)

/usr/bin/resty
%{orprefix}/bin/resty


%files doc
%defattr(-,root,root,-)

%dir %{orprefix}/pod
/usr/bin/restydoc
%{orprefix}/bin/restydoc
%{orprefix}/bin/restydoc-index
%{orprefix}/bin/md2pod.pl
%{orprefix}/bin/nginx-xml2pod
%{orprefix}/pod/*
%{orprefix}/resty.index


%files opm
%defattr(-,root,root,-)

/usr/bin/opm
%dir %{orprefix}/site
%dir %{orprefix}/site/pod
%dir %{orprefix}/site/manifest
%{orprefix}/bin/opm
%{orprefix}/site/manifest/
%{orprefix}/site/pod/


%changelog
* Wed Aug 14 2024 Pengda Dou <doupengda@loongson.cn> - 1.21.4.4-2
- [Type] other
- [DESC] add loongarch64 to ExcludeArch

* Thu Jul 25 2024 Feng Weiyao <wynnfeng@tencent.com> - 1.21.4.4-1
- [Type] security
- [DESC] update to 1.21.4.4 to fix CVE-2024-39702

* Sat Jul 06 2024 Liangliang Zhai <zhailiangliang@loongson.cn> - 1.21.4.3-7
- [Type] other
- [DESC] Remove macro loongarch64 for avoiding not finding loongarch patch
         Modify add-loongarch-support.patch for delete unnecessary modifications

* Fri Jun 07 2024 Liangliang Zhai <zhailiangliang@loongson.cn> - 1.21.4.3-6
- [Type] other
- [DESC] add loongarch support

* Fri Apr 26 2024 Rebuild Robot <rebot@opencloudos.org> - 1.21.4.3-5
- [Type] other
- [DESC] Rebuilt for openresty-openssl111

* Tue Feb 20 2024 Rebuild Robot <rebot@opencloudos.org> - 1.21.4.3-4
- Rebuilt for openresty-openssl111

* Fri Feb 02 2024 Rebuild Robot <rebot@opencloudos.org> - 1.21.4.3-3
- Rebuilt for openresty-pcre

* Fri Dec 8 2023 Feng Weiyao <wynnfeng@tencent.com> - 1.21.4.3-2
- initial build for opencloudos

* Thu Oct 26 2023 Yichun Zhang (agentzh) 1.21.4.3-1
- upgraded openresty to 1.21.4.3.

* Mon Jul 17 2023 Yichun Zhang (agentzh) 1.21.4.2-1
- upgraded openresty to 1.21.4.2.

* Tue May 17 2022 Yichun Zhang (agentzh) 1.21.4.1-1
- upgraded openresty to 1.21.4.1.

* Fri Aug 6 2021 Yichun Zhang (agentzh) 1.19.9.1-1
- upgraded openresty to 1.19.9.1.

* Mon May 31 2021 Yichun Zhang (agentzh) 1.19.3.2-1
- upgraded openresty to 1.19.3.2.

* Fri Nov 6 2020 Yichun Zhang (agentzh) 1.19.3.1-1
- upgraded openresty to 1.19.3.1.

* Mon Jul 13 2020 Yichun Zhang (agentzh) 1.17.8.2-1
- upgraded openresty to 1.17.8.2.

* Fri Jul 3 2020 Yichun Zhang (agentzh) 1.17.8.1-1
- upgraded openresty to 1.17.8.1.

* Thu Aug 29 2019 Yichun Zhang (agentzh) 1.15.8.2-1
- upgraded openresty to 1.15.8.2.

* Thu May 16 2019 Yichun Zhang (agentzh) 1.15.8.1-1
- upgraded openresty to 1.15.8.1.

* Mon May 14 2018 Yichun Zhang (agentzh) 1.13.6.2-1
- upgraded openresty to 1.13.6.2.

* Sun Nov 12 2017 Yichun Zhang (agentzh) 1.13.6.1-1
- upgraded openresty to 1.13.6.1.

* Thu Sep 21 2017 Yichun Zhang (agentzh) 1.11.2.5-2
- enabled -DNGX_LUA_ABORT_AT_PANIC by default.

* Thu Aug 17 2017 Yichun Zhang (agentzh) 1.11.2.5-1
- upgraded OpenResty to 1.11.2.5.

* Tue Jul 11 2017 Yichun Zhang (agentzh) 1.11.2.4-1
- upgraded OpenResty to 1.11.2.4.

* Sat May 27 2017 Yichun Zhang (agentzh) 1.11.2.3-14
- bugfix: the openresty-opm subpackage did not depend on openresty-doc and openresty-resty.

* Sat May 27 2017 Yichun Zhang (agentzh) 1.11.2.3-14
- centos 6 and opensuse do not have the groff-base package.

* Sat May 27 2017 Yichun Zhang (agentzh) 1.11.2.3-13
- openresty-doc now depends on groff-base.

* Thu May 25 2017 Yichun Zhang (agentzh) 1.11.2.3-12
- added missing groff/pod2txt/pod2man dependencies for openresty-doc.

* Thu May 25 2017 Yichun Zhang (agentzh) 1.11.2.3-11
- added missing perl dependencies for openresty-opm, openresty-resty, and openresty-doc.

* Sun May 21 2017 Yichun Zhang (agentzh) 1.11.2.3-10
- removed the geoip nginx module since GeoIP is not available everywhere.

* Fri Apr 21 2017 Yichun Zhang (agentzh)
- upgrade to the OpenResty 1.11.2.3 release: http://openresty.org/en/changelog-1011002.html

* Sat Dec 24 2016 Yichun Zhang
- init script: explicity specify the runlevels 345.

* Wed Dec 14 2016 Yichun Zhang
- opm missing runtime dependencies curl, tar, and gzip.
- enabled http_geoip_module by default.

* Fri Nov 25 2016 Yichun Zhang
- opm missing runtime dependency perl(Digest::MD5)

* Thu Nov 17 2016 Yichun Zhang
- upgraded OpenResty to 1.11.2.2.

* Fri Aug 26 2016 Yichun Zhang
- use dual number mode in our luajit builds which should usually
be faster for web application use cases.

* Wed Aug 24 2016 Yichun Zhang
- bump OpenResty version to 1.11.2.1.

* Tue Aug 23 2016 zxcvbn4038
- use external packages openresty-zlib and openresty-pcre through dynamic linking.

* Thu Jul 14 2016 Yichun Zhang
- enabled more nginx standard modules as well as threads and file aio.

* Sun Jul 10 2016 makerpm
- initial build for OpenResty 1.9.15.1.
